C********************************************************************
C
C     PROGRAM PTTEND
C     
C     ʿʿǮٱľʬۿ޺ץ
C
C     1998/09/22  
C     1998/10/02  
C     1999/02/04  
C     1999/06/15  
C
C*********************************************************************
      program pttend
      implicit real*8 ( a-h, o-z )
C---------------------------------------------------------------------  
#include "grid_size_M.f"
      parameter ( nzprof = 100 )
      parameter ( nzp = nz+1   )
C---------------------------------------------------------------------  
      parameter ( day = 86400.0 )
      parameter ( hour = 3600.0 )
C                                                                       
      character*5  nmrun
      character*4  from
      character*1  chara
      character*1  pz

      character*2  start
      character*2  finish
      character*2  date      
      character*20 header

      real*4 ekvis(nzp), eknlv(nzp), ekbuoy(nzp)

      real*4  zgrid(nzp),tptend(nzp),tpmean(nzp),
     &        dtpadv(nzp),dtpdif(nzp),dtpdnl(nzp),
     &        dtpdi0(nzp),dtpad0(nzp),dtpdis(nzp),
     &        tperror(nzp),dtirad(nzp),dtsrad(nzp)

      real*4  tptend_p(nzp),dtpadv_p(nzp),dtpdif_p(nzp),
     &        dtpdis_p(nzp),dtirad_p(nzp),dtsrad_p(nzp)

      real*4 time(100), heat(100)
      real*4 sflux_h, RMAX1, RMIN1, RMAX2, RMIN2

      integer fnum, begin, end, interv
      integer nloop1
      character CSGI*1

*-----------------------------------------------------

      real*4 z0(-2:nzb), p0(-2:nzb), d0(-2:nzb), 
     \       temp0(-2:nzb), tpot0(-2:nzb), ppai0(-2:nzb)

*-----------------------------------------------------

      RMAX1 = 100.0
      RMIN1 = - RMAX1
      RMAX2 = 1200.0
      RMIN2 = - RMAX2

      call SETCST( grav, psd, amdry, rdry, cpdry, rmvap, alatent )

      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu, times
      read (11,*) ylat, als
      close(11)
      
      tinterv = nloop2 * ( dtime / 2. )

      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, z0(iz), p0(iz), d0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), dum1, dum2
      end do

      call FCLOSE

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv
      
      call sgpwsn
      read(*,*) iws

      CALL SWISET('IWIDTH', 420)
      CALL SWISET('IHEIGHT', 420)
      call swlset( 'LDUMP', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )

      call gropn(iws)
     
      do it = 1, ite

      fnum = 50 + it
      open(fnum)

!********************************************************************
! * kinetic energy production & dissipation *

      read(fnum,'(a2,a15,g15.7,a6,g15.7,a4)') 
     &     chara, nmrun, t_begin, from, t_end,
     &     pz

      do iz = 1, nzp
         read(fnum,*) zgrid(iz), 
     &           ekvis(iz),
     &           eknlv(iz),
     &           ekbuoy(iz)
         end do

!********************************************************************

      read(fnum,'(a2,a15,g15.7,a6,g15.7,a4)') 
     &     chara, nmrun, t_begin, from, t_end,
     &     pz

!********************************************************************
      if ( t_begin .eq. 0.0 ) then
         t_begin = t_end - tinterv
      end if

      begin = INT( t_begin -  INT( t_begin / day ) * day )
      end   = INT( t_end -  INT( t_begin / day ) * day )

      t_begin = t_begin + times
      t_end   = t_end   + times

      write(date, '(I2.2)') INT( t_begin / day + 1 )

      t_begin = ( t_begin - INT( t_begin / day ) * day  ) / hour 
      t_end   = ( t_end   - INT( t_end   / day ) * day  ) / hour 
      
      if ( INT(t_begin) .ge. 24 ) then
         t_begin = t_begin - 24
      end if

      if ( INT(t_end) .ge. 24 ) then
         t_end = t_end - 24
      end if

      write(start,'(I2.2)') INT(t_begin)
      write(finish,'(I2.2)') INT(t_end)

!********************************************************************

      header = 'day' // date // 
     \     ' LT=' // start // ':00-' // finish // ':00'


      read(fnum,*) AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL

      do iz = 1, nzp-1
         read(fnum,*) zgrid(iz), 
     &                        tperror(iz),
     &                        tptend(iz),
     &                        tpmean(iz),
     &                        dtpadv(iz),
     &                        dtpdif(iz),
     &                        dtpdnl(iz),
     &                        dtpad0(iz),
     &                        dtpdi0(iz),
     &                        dtpdis(iz),
     &                        dtirad(iz),
     &                        dtsrad(iz)
      end do

      close(fnum)

      if ( it .ge. itb   .and.  it .le. ite ) then
      if ( mod( (it-itb), interv ) .eq. 0 ) then

      open(13)
      read(13,*) (time(j),j=1,nloop1),(heat(j),j=1,nloop1)
      close(13)

      begin = begin / tinterv
      end   = end / tinterv

      do i = 1, nloop1
         heat(i) = heat(i)/tinterv
      end do

      interval = end - begin + 1

      sflux_h = 0.
      do i = begin, end
         sflux_h = sflux_h + heat(i) / interval
      end do

      sflux_h = sflux_h / ( cpdry * d0(0) * z0(0)*2 * 51200.)

      dtpdif(1) = dtpdif(1) + sflux_h

      do iz = 1, nzp-1
         zgrid(iz) = zgrid(iz) / 1000.
         dtpdif_p(iz) = ( dtpdif(iz) + dtpdi0(iz) )* day
         tptend_p(iz) = tptend(iz) * day
         dtpadv_p(iz) = ( dtpadv(iz) + dtpad0(iz) + dtpdnl(iz) )* day
         dtpdis_p(iz) = dtpdis(iz) * day
         dtirad_p(iz) = dtirad(iz) * day
         dtsrad_p(iz) = dtsrad(iz) * day

         ekvis(iz) = ekvis(iz) * day
         eknlv(iz) = eknlv(iz) * day

         dtirad_p(iz) = dtirad_p(iz) + ekvis(iz)
         dtsrad_p(iz) = dtsrad_p(iz) + eknlv(iz)


         if ( dtpadv_p(iz) .gt. RMAX1 ) then
            dtpadv_p(iz) = RMAX1
         else if ( dtpadv_p(iz) .lt. RMIN1 ) then
            dtpadv_p(iz) = RMIN1
         end if
         
         if ( dtirad_p(iz) .gt. RMAX1 ) then
            dtirad_p(iz) = RMAX1
         else if ( dtirad_p(iz) .lt. RMIN1 ) then
            dtirad_p(iz) = RMIN1
         end if

         if ( dtpdis_p(iz) .gt. RMAX1 ) then
            dtpdis_p(iz) = RMAX1
         else if ( dtpdis_p(iz) .lt. RMIN1 ) then
            dtpdis_p(iz) =  RMIN1
         end if
         
         if ( dtpdif_p(iz) .gt. RMAX1 ) then
            dtpdif_p(iz) = RMAX1
         else if ( dtpdif_p(iz) .lt. RMIN1 ) then
            dtpdif_p(iz) =  RMIN1
         end if

      end do

C      write(*,*) dtirad_p(1), ekvis(1), dtsrad_p(1), eknlv(1)

      call grfrm
      call grswnd( RMIN1, RMAX1, 0., 20. )
      call grsvpt( 0.2, 0.8, 0.35, 0.85 )
      call grstrn(1)
      call grstrf
      call ussttl ( '', '', '', 'Z[km]' )
      call usdaxs
      call uxsttl ( 'T', header, 1. )
      call sglset( 'LCHAR', .TRUE. )

      call SGSPLI( 773 )
      call SGPLU( nz, dtpadv_p, zgrid )
      call SGSPLI( 33 )
      call sgplu(nz, dtpdif_p, zgrid )
      call SGSPLI( 63 )
      call sgplu(nz, dtpdis_p, zgrid )

      call SGSPLI( 23 )
      call sgplu(nz, dtirad_p, zgrid )
      call SGSPLI( 43 )
      call sgplu(nz, dtsrad_p, zgrid )


      do iz = 1, nzp-1
         dtpdif_p(iz) = ( dtpdif(iz) + dtpdi0(iz) )* day
         tptend_p(iz) = tptend(iz) * day
         dtpadv_p(iz) = ( dtpadv(iz) + dtpad0(iz) + dtpdnl(iz) )* day
         dtpdis_p(iz) = dtpdis(iz) * day
         dtirad_p(iz) = dtirad(iz) * day
         dtsrad_p(iz) = dtsrad(iz) * day

         if ( dtpadv_p(iz) .gt. RMAX2 ) then
            dtpadv_p(iz) = RMAX2
         else if ( dtpadv_p(iz) .lt. RMIN2 ) then
            dtpadv_p(iz) = RMIN2
         end if

         if ( dtirad_p(iz) .gt. RMAX2 ) then
            dtirad_p(iz) = RMAX2
         else if ( dtirad_p(iz) .lt. RMIN2 ) then
            dtirad_p(iz) = RMIN2
         end if
        
         if ( dtpdis_p(iz) .gt. RMAX2 ) then
            dtpdis_p(iz) = RMAX2
         else if ( dtpdis_p(iz) .lt. RMIN2 ) then
            dtpdis_p(iz) =  RMIN2
         end if
         
         if ( dtpdif_p(iz) .gt. RMAX2 ) then
            dtpdif_p(iz) = RMAX2
         else if ( dtpdif_p(iz) .lt. RMIN2 ) then
            dtpdif_p(iz) =  RMIN2
         end if


      end do

      call grfig
      call grswnd( RMIN2, RMAX2, 0., 1. )
      call grsvpt( 0.2, 0.8, 0.2, 0.3 )
      call grstrn(1)
      call grstrf
      call uxaxdv ( 'B', 100., 500. )
      call uxaxdv ( 'T', 100., 500. )
      call uyaxdv ( 'L', 0.2, 1. )
      call uyaxdv ( 'R', 0.2, 1. )
      call uzfact(0.8)
      call uxsttl( 'B', 'K/day', 1.2 )
      call uzfact(1.25)
      call uxsttl( 'B', 'd'//CSGI(135)//'/dt', 0. )

      call SGSPLI( 773 )
      call SGPLU( 15, dtpadv_p, zgrid )
      call SGSPLI( 33 )
      call sgplu(15, dtpdif_p, zgrid )
      call SGSPLI( 63 )
      call sgplu(15, dtpdis_p, zgrid )

      call SGSPLI( 23 )
      call sgplu(15, dtirad_p, zgrid )
      call SGSPLI( 43 )
      call sgplu(15, dtsrad_p, zgrid )


      end if
      end if

      end do


      call grcls

      end



